HDOJ4252A Famous City --- 单调栈

题目链接 http://acm.hdu.edu.cn/showproblem.php?pid=4252

Problem Description

After Mr. B arrived in Warsaw, he was shocked by the skyscrapers and took several photos. But now when he looks at these photos, he finds in surprise that he isn't able to point out even the number of buildings in it. So he decides to work it out as follows:
- divide the photo into n vertical pieces from left to right. The buildings in the photo can be treated as rectangles, the lower edge of which is the horizon. One building may span several consecutive pieces, but each piece can only contain one visible building, or no buildings at all.
- measure the height of each building in that piece.
- write a program to calculate the minimum number of buildings.
Mr. B has finished the first two steps, the last comes to you.

 

 

Input

Each test case starts with a line containing an integer n (1 <= n <= 100,000). Following this is a line containing n integers - the height of building in each piece respectively. Note that zero height means there are no buildings in this piece at all. All the input numbers will be nonnegative and less than 1,000,000,000.

 

 

Output

For each test case, display a single line containing the case number and the minimum possible number of buildings in the photo.

 

 

Sample Input

 

3 1 2 3 3 1 2 1

 

 

Sample Output

 

Case 1: 3 Case 2: 2

Hint

The possible configurations of the samples are illustrated below:

题意:英语太菜了,读了两遍题没完全理解意思。看了网上几篇博客才看懂。。

大概意思是,一张照片上拍出了一些楼房(如上图,从正面看),每栋房子顶部是平的,宽度可能不同,房子的前后位置不能确定。要求给出从左到右各个高度,算出最少有多少楼房。

比如右上图,高度为1 2 1,但是那两个蓝色的可能是一栋楼,只是中间部分被前面那个高度为2的楼遮住了,所以最少有2栋楼。

再比如给出5个高度 1 3 1 0 1,则至少有3栋楼。

 题解:这题如果不给任何提示的话我多半想不到好的方法,但是因为是专门搜单调栈练习题,所以才知道这题怎么做。。

这题正解是使用单调递增栈(新入栈的元素比栈的前面入栈的元素大),从左到右扫一遍数组,当前的高度如果比栈顶元素大,那就说明出现了新的一栋楼,那就将其入栈,并且结果cnt+1,如果和栈顶元素一样大,那就说明它和左边是同一栋楼,就不加1直接跳过,如果当前的数小于栈顶,那说明①当前的楼有可能和栈中前面的楼是同一栋,只是中间部分被高楼遮住了 ②栈中比当前元素大的,可以弹出栈了,因为后面再遇到和它们一样高的,不可能是同一栋楼了。(栈中保存的元素是因为可能和后面的是同一栋楼才保存在栈里面)。  所以这时就为了维护栈的单调性,将大于当前元素的栈顶弹出,之后的处理方法和前面一样。

需要注意的是高度为0的要特殊处理,不能统计在内,还有就是注意判断栈空。

#include <cstdio>
#include <algorithm>
#include <cstring>
#include <stack>
using namespace std;
stack<int> s;
int n;
int main()
{
    int Case = 1;
    while(scanf("%d",&n) != EOF) {
        while(!s.empty()) s.pop(); // 清空栈
        int cnt = 0;
        int t;
        for(int i = 0;i < n;i++) {
            scanf("%d",&t);
            if(s.empty()) {
            	if(t != 0) {				
                	s.push(t);                
                	cnt++;
            	}
            } else {
                while( !s.empty() && (t < s.top()) ) {
                    s.pop();
                }
                if(s.empty()) {
                	if(t != 0) {					
                    	s.push(t);
                    	cnt++;
                	}
                } else if(t > s.top()) {
                    cnt++;
                    s.push(t);
                }
            }
        }
        
        printf("Case %d: %d\n",Case++,cnt);
        
    }
    
    return 0;
} 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值